tbb::flow::interface11::limiter_node< T, DecrementType > Class Template Reference

Forwards messages only if the threshold has not been reached. More...

`#include <flow_graph.h>`

Inheritance diagram for tbb::flow::interface11::limiter_node< T, DecrementType >:
Collaboration diagram for tbb::flow::interface11::limiter_node< T, DecrementType >:

## Public Types

typedef T | input_type
typedef T | output_type
typedef receiver< input_type >::predecessor_type | predecessor_type
typedef sender< output_type >::successor_type | successor_type
Public Types inherited from tbb::flow::interface11::internal::untyped_receiver
typedef untyped_sender | predecessor_type
| The predecessor type for this node. More...
Public Types inherited from tbb::flow::interface11::internal::untyped_sender
typedef untyped_receiver | successor_type
| The successor type for this node. More...

## Public Member Functions

| limiter_node (graph &g, __TBB_DEPRECATED_LIMITER_ARG2(size_t threshold, int num_decrement_predecessors=0))
| Constructor. More...
| limiter_node (const limiter_node &src)
| Copy constructor. More...
bool | register_successor (successor_type &r) __TBB_override
| Replace the current successor with this new successor. More...
bool | remove_successor (successor_type &r) __TBB_override
| Removes a successor from this node. More...
bool | register_predecessor (predecessor_type &src) __TBB_override
| Adds src to the list of cached predecessors. More...
bool | remove_predecessor (predecessor_type &src) __TBB_override
| Removes src from the list of cached predecessors. More...
Public Member Functions inherited from tbb::flow::interface11::graph_node
| graph_node (graph &g)
virtual | ~graph_node ()
Public Member Functions inherited from tbb::flow::interface11::receiver< T >
bool | try_put (const typename internal::async_helpers< T >::filtered_type &t)
| Put an item to the receiver. More...
bool | try_put (const typename internal::async_helpers< T >::async_type &t)
Public Member Functions inherited from tbb::flow::interface11::internal::untyped_receiver
virtual | ~untyped_receiver ()
| Destructor. More...
template<typename X >
bool | try_put (const X &t)
| Put an item to the receiver. More...
Public Member Functions inherited from tbb::flow::interface11::sender< T >
virtual bool | try_get (T &)
| Request an item from the sender. More...
virtual bool | try_reserve (T &)
| Reserves an item in the sender. More...
Public Member Functions inherited from tbb::flow::interface11::internal::untyped_sender
virtual | ~untyped_sender ()
virtual bool | try_release ()
| Releases the reserved item. More...
virtual bool | try_consume ()
| Consumes the reserved item. More...

## Public Attributes

internal::decrementer< limiter_node< T, DecrementType >, DecrementType > | decrement
| The internal receiver< DecrementType > that decrements the count. More...
Public Attributes inherited from tbb::flow::interface11::receiver< T >
__TBB_DEPRECATED typedef T | input_type
| The input type of this receiver. More...
__TBB_DEPRECATED typedef internal::async_helpers< T >::filtered_type | filtered_type
Public Attributes inherited from tbb::flow::interface11::sender< T >
__TBB_DEPRECATED typedef T | output_type
| The output type of this sender. More...
__TBB_DEPRECATED typedef internal::async_helpers< T >::filtered_type | filtered_type

## Protected Member Functions

task * | try_put_task (const T &t) __TBB_override
| Puts an item to this receiver. More...
graph & | graph_reference () const __TBB_override
void | reset_receiver (reset_flags) __TBB_override
| put receiver back in initial state More...
void | reset_node (reset_flags f) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::receiver< T >
virtual task * | try_put_task_wrapper (const void *p, bool is_async) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::internal::untyped_receiver
template<typename X >
task * | try_put_task (const X &t)
virtual bool | is_continue_receiver ()
Protected Member Functions inherited from tbb::flow::interface11::sender< T >
virtual bool | try_get_wrapper (void *p, bool is_async) __TBB_override
virtual bool | try_reserve_wrapper (void *p, bool is_async) __TBB_override
Protected Member Functions inherited from tbb::flow::interface11::internal::untyped_sender
template<typename X >
bool | try_get (X &t)
| Request an item from the sender. More...
template<typename X >
bool | try_reserve (X &t)
| Reserves an item in the sender. More...

## Private Member Functions

bool | check_conditions ()
task * | forward_task ()
void | forward ()
task * | decrement_counter (long long delta)
void | initialize ()

## Private Attributes

size_t | my_threshold
size_t | my_count
size_t | my_tries
internal::reservable_predecessor_cache< T, spin_mutex > | my_predecessors
spin_mutex | my_mutex
internal::broadcast_cache< T > | my_successors

## Friends

class | internal::forward_task_bypass< limiter_node< T, DecrementType > >
class | internal::decrementer< limiter_node< T, DecrementType >, DecrementType >
template<typename R , typename B >
class | run_and_put_task
template<typename X , typename Y >
class | internal::broadcast_cache
template<typename X , typename Y >
class | internal::round_robin_cache

## Additional Inherited Members

Protected Attributes inherited from tbb::flow::interface11::graph_node
graph & | my_graph
graph_node * | next
graph_node * | prev

## Detailed Description

### template<typename T, typename DecrementType = continue_msg>
class tbb::flow::interface11::limiter_node< T, DecrementType >

Forwards messages only if the threshold has not been reached.

This node forwards items until its threshold is reached. It contains no buffering. If the downstream node rejects, the message is dropped.

Definition at line 2985 of file flow_graph.h.

## Member Typedef Documentation

## input_type

template<typename T , typename DecrementType = continue_msg>

typedef T tbb::flow::interface11::limiter_node< T, DecrementType >::input_type

Definition at line 2987 of file flow_graph.h.

## output_type

template<typename T , typename DecrementType = continue_msg>

typedef T tbb::flow::interface11::limiter_node< T, DecrementType >::output_type

Definition at line 2988 of file flow_graph.h.

## predecessor_type

template<typename T , typename DecrementType = continue_msg>

typedef receiver<input_type>::predecessor_type tbb::flow::interface11::limiter_node< T, DecrementType >::predecessor_type

Definition at line 2989 of file flow_graph.h.

## successor_type

template<typename T , typename DecrementType = continue_msg>

typedef sender<output_type>::successor_type tbb::flow::interface11::limiter_node< T, DecrementType >::successor_type

Definition at line 2990 of file flow_graph.h.

## Constructor & Destructor Documentation

## limiter_node() [1/2]

template<typename T , typename DecrementType = continue_msg>

tbb::flow::interface11::limiter_node< T, DecrementType >::limiter_node | ( | graph & | g,
|  | __TBB_DEPRECATED_LIMITER_ARG2(size_t threshold, int num_decrement_predecessors=0) |
| ) |  |

inline

Constructor.

Definition at line 3110 of file flow_graph.h.

: graph_node(g), my_threshold(threshold), my_count(0),
__TBB_DEPRECATED_LIMITER_ARG4(
my_tries(0), decrement(),
init_decrement_predecessors(num_decrement_predecessors),
decrement(num_decrement_predecessors)) {
initialize();
}
__TBB_DEPRECATED_LIMITER_ARG4
#define __TBB_DEPRECATED_LIMITER_ARG4(arg1, arg2, arg3, arg4)
Definition: _flow_graph_impl.h:54
tbb::flow::interface11::limiter_node::my_tries
size_t my_tries
Definition: flow_graph.h:3002
tbb::flow::interface11::limiter_node::my_threshold
size_t my_threshold
Definition: flow_graph.h:3000
tbb::flow::interface11::limiter_node::decrement
internal::decrementer< limiter_node< T, DecrementType >, DecrementType > decrement
The internal receiver< DecrementType > that decrements the count.
Definition: flow_graph.h:3101
tbb::flow::interface11::limiter_node::my_count
size_t my_count
Definition: flow_graph.h:3001
tbb::flow::interface11::limiter_node::initialize
void initialize()
Definition: flow_graph.h:3089
tbb::flow::interface11::graph_node::graph_node
graph_node(graph &g)
Definition: flow_graph.h:888

References tbb::flow::interface11::limiter_node< T, DecrementType >::initialize().

Here is the call graph for this function:

## limiter_node() [2/2]

template<typename T , typename DecrementType = continue_msg>

tbb::flow::interface11::limiter_node< T, DecrementType >::limiter_node | ( | const limiter_node< T, DecrementType > & | src | ) |

inline

Copy constructor.

Definition at line 3129 of file flow_graph.h.

:
graph_node(src.my_graph), receiver<T>(), sender<T>(),
my_threshold(src.my_threshold), my_count(0),
__TBB_DEPRECATED_LIMITER_ARG4(
my_tries(0), decrement(),
init_decrement_predecessors(src.init_decrement_predecessors),
decrement(src.init_decrement_predecessors)) {
initialize();
}

References tbb::flow::interface11::limiter_node< T, DecrementType >::initialize().

Here is the call graph for this function:

## Member Function Documentation

## check_conditions()

template<typename T , typename DecrementType = continue_msg>

bool tbb::flow::interface11::limiter_node< T, DecrementType >::check_conditions | ( |  | ) |

inline private

Definition at line 3013 of file flow_graph.h.

{ // always called under lock
return ( my_count + my_tries < my_threshold && !my_predecessors.empty() && !my_successors.empty() );
}
tbb::flow::interface11::limiter_node::my_successors
internal::broadcast_cache< T > my_successors
Definition: flow_graph.h:3005
tbb::flow::interface11::limiter_node::my_predecessors
internal::reservable_predecessor_cache< T, spin_mutex > my_predecessors
Definition: flow_graph.h:3003

References tbb::flow::interface11::limiter_node< T, DecrementType >::my_count, tbb::flow::interface11::limiter_node< T, DecrementType >::my_predecessors, tbb::flow::interface11::limiter_node< T, DecrementType >::my_successors, tbb::flow::interface11::limiter_node< T, DecrementType >::my_threshold, and tbb::flow::interface11::limiter_node< T, DecrementType >::my_tries.

Referenced by tbb::flow::interface11::limiter_node< T, DecrementType >::forward_task(), and tbb::flow::interface11::limiter_node< T, DecrementType >::try_put_task().

Here is the caller graph for this function:

## decrement_counter()

template<typename T , typename DecrementType = continue_msg>

task* tbb::flow::interface11::limiter_node< T, DecrementType >::decrement_counter | ( | long long | delta | ) |

inline private

Definition at line 3076 of file flow_graph.h.

{
{
spin_mutex::scoped_lock lock(my_mutex);
if( delta > 0 && size_t(delta) > my_count )
my_count = 0;
else if( delta < 0 && size_t(delta) > my_threshold - my_count )
my_count = my_threshold;
else
my_count -= size_t(delta); // absolute value of delta is sufficiently small
}
return forward_task();
}
lock
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t ITT_FORMAT d void ITT_FORMAT p void ITT_FORMAT p __itt_model_site __itt_model_site_instance ITT_FORMAT p __itt_model_task __itt_model_task_instance ITT_FORMAT p void * lock
Definition: ittnotify_static.h:121
tbb::flow::interface11::limiter_node::my_mutex
spin_mutex my_mutex
Definition: flow_graph.h:3004
tbb::flow::interface11::limiter_node::forward_task
task * forward_task()
Definition: flow_graph.h:3018
tbb::spin_mutex::scoped_lock
friend class scoped_lock
Definition: spin_mutex.h:179

References tbb::flow::interface11::limiter_node< T, DecrementType >::forward_task(), lock, tbb::flow::interface11::limiter_node< T, DecrementType >::my_count, tbb::flow::interface11::limiter_node< T, DecrementType >::my_mutex, and tbb::flow::interface11::limiter_node< T, DecrementType >::my_threshold.

Here is the call graph for this function:

## forward()

template<typename T , typename DecrementType = continue_msg>

void tbb::flow::interface11::limiter_node< T, DecrementType >::forward | ( |  | ) |

inline private

Definition at line 3071 of file flow_graph.h.

{
__TBB_ASSERT(false, "Should never be called");
return;
}
__TBB_ASSERT
#define __TBB_ASSERT(predicate, comment)
No-op version of __TBB_ASSERT.
Definition: tbb_stddef.h:165

References __TBB_ASSERT.

## forward_task()

template<typename T , typename DecrementType = continue_msg>

task* tbb::flow::interface11::limiter_node< T, DecrementType >::forward_task | ( |  | ) |

inline private

Definition at line 3018 of file flow_graph.h.

{
input_type v;
task *rval = NULL;
bool reserved = false;
{
spin_mutex::scoped_lock lock(my_mutex);
if ( check_conditions() )
++my_tries;
else
return NULL;
}
//SUCCESS
// if we can reserve and can put, we consume the reservation
// we increment the count and decrement the tries
if ( (my_predecessors.try_reserve(v)) == true ){
reserved=true;
if ( (rval = my_successors.try_put_task(v)) != NULL ){
{
spin_mutex::scoped_lock lock(my_mutex);
++my_count;
--my_tries;
my_predecessors.try_consume();
if ( check_conditions() ) {
if ( internal::is_graph_active(this->my_graph) ) {
task *rtask = new ( task::allocate_additional_child_of( *(this->my_graph.root_task()) ) )
internal::forward_task_bypass< limiter_node<T, DecrementType> >( *this );
internal::spawn_in_graph_arena(graph_reference(), *rtask);
}
}
}
return rval;
}
}
//FAILURE
//if we can't reserve, we decrement the tries
//if we can reserve but can't put, we decrement the tries and release the reservation
{
spin_mutex::scoped_lock lock(my_mutex);
--my_tries;
if (reserved) my_predecessors.try_release();
if ( check_conditions() ) {
if ( internal::is_graph_active(this->my_graph) ) {
task *rtask = new ( task::allocate_additional_child_of( *(this->my_graph.root_task()) ) )
internal::forward_task_bypass< limiter_node<T, DecrementType> >( *this );
__TBB_ASSERT(!rval, "Have two tasks to handle");
return rtask;
}
}
return rval;
}
}
task
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t ITT_FORMAT d void ITT_FORMAT p void ITT_FORMAT p __itt_model_site __itt_model_site_instance ITT_FORMAT p __itt_model_task * task
Definition: ittnotify_static.h:119
tbb::flow::interface11::internal::spawn_in_graph_arena
void spawn_in_graph_arena(tbb::flow::interface10::graph &g, tbb::task &arena_task)
Spawns a task inside graph arena.
Definition: _flow_graph_impl.h:521
tbb::flow::interface11::internal::is_graph_active
bool is_graph_active(tbb::flow::interface10::graph &g)
Definition: _flow_graph_impl.h:494
tbb::flow::interface11::limiter_node::graph_reference
graph & graph_reference() const __TBB_override
Definition: flow_graph.h:3260
tbb::flow::interface11::limiter_node::input_type
T input_type
Definition: flow_graph.h:2987
tbb::flow::interface11::limiter_node::check_conditions
bool check_conditions()
Definition: flow_graph.h:3013
internal::forward_task_bypass
A task that calls a node's forward_task function.
Definition: _flow_graph_body_impl.h:328
tbb::flow::interface10::graph::root_task
__TBB_DEPRECATED tbb::task * root_task()
Returns the root task of the graph.
Definition: _flow_graph_impl.h:374
tbb::flow::interface11::graph_node::my_graph
graph & my_graph
Definition: _flow_graph_impl.h:464

References __TBB_ASSERT, tbb::flow::interface11::limiter_node< T, DecrementType >::check_conditions(), tbb::flow::interface11::limiter_node< T, DecrementType >::graph_reference(), tbb::flow::interface11::internal::is_graph_active(), lock, tbb::flow::interface11::limiter_node< T, DecrementType >::my_count, tbb::flow::interface11::graph_node::my_graph, tbb::flow::interface11::limiter_node< T, DecrementType >::my_mutex, tbb::flow::interface11::limiter_node< T, DecrementType >::my_predecessors, tbb::flow::interface11::limiter_node< T, DecrementType >::my_successors, tbb::flow::interface11::limiter_node< T, DecrementType >::my_tries, tbb::flow::interface10::graph::root_task(), and tbb::flow::interface11::internal::spawn_in_graph_arena().

Referenced by tbb::flow::interface11::limiter_node< T, DecrementType >::decrement_counter().

Here is the call graph for this function:
Here is the caller graph for this function:

## graph_reference()

template<typename T , typename DecrementType = continue_msg>

graph& tbb::flow::interface11::limiter_node< T, DecrementType >::graph_reference | ( |  | ) | const

inline protected virtual

Implements tbb::flow::interface11::internal::untyped_receiver.

Definition at line 3260 of file flow_graph.h.

{ return my_graph; }

References tbb::flow::interface11::graph_node::my_graph.

Referenced by tbb::flow::interface11::limiter_node< T, DecrementType >::forward_task(), tbb::flow::interface11::limiter_node< T, DecrementType >::register_predecessor(), and tbb::flow::interface11::limiter_node< T, DecrementType >::register_successor().

Here is the caller graph for this function:

## initialize()

template<typename T , typename DecrementType = continue_msg>

void tbb::flow::interface11::limiter_node< T, DecrementType >::initialize | ( |  | ) |

inline private

Definition at line 3089 of file flow_graph.h.

{
my_predecessors.set_owner(this);
my_successors.set_owner(this);
decrement.set_owner(this);
tbb::internal::fgt_node(
CODEPTR(), tbb::internal::FLOW_LIMITER_NODE, &this->my_graph,
static_cast<receiver<input_type> *>(this), static_cast<receiver<DecrementType> *>(&decrement),
static_cast<sender<output_type> *>(this)
);
}
CODEPTR
#define CODEPTR()
Definition: _flow_graph_trace_impl.h:297
tbb::internal::fgt_node
static void fgt_node(void *, string_index, void *, void *)
Definition: _flow_graph_trace_impl.h:326

References CODEPTR, tbb::flow::interface11::limiter_node< T, DecrementType >::decrement, tbb::internal::fgt_node(), tbb::flow::interface11::graph_node::my_graph, tbb::flow::interface11::limiter_node< T, DecrementType >::my_predecessors, and tbb::flow::interface11::limiter_node< T, DecrementType >::my_successors.

Referenced by tbb::flow::interface11::limiter_node< T, DecrementType >::limiter_node().

Here is the call graph for this function:
Here is the caller graph for this function:

## register_predecessor()

template<typename T , typename DecrementType = continue_msg>

bool tbb::flow::interface11::limiter_node< T, DecrementType >::register_predecessor | ( | predecessor_type & | src | ) |

inline virtual

Adds src to the list of cached predecessors.

Reimplemented from tbb::flow::interface11::internal::untyped_receiver.

Definition at line 3210 of file flow_graph.h.

{
spin_mutex::scoped_lock lock(my_mutex);
my_predecessors.add( src );
if ( my_count + my_tries < my_threshold && !my_successors.empty() && internal::is_graph_active(this->my_graph) ) {
task* task = new ( task::allocate_additional_child_of( *(this->my_graph.root_task()) ) )
internal::forward_task_bypass < limiter_node<T, DecrementType> >( *this );
internal::spawn_in_graph_arena(graph_reference(), *task);
}
return true;
}

References tbb::flow::interface11::limiter_node< T, DecrementType >::graph_reference(), tbb::flow::interface11::internal::is_graph_active(), lock, tbb::flow::interface11::limiter_node< T, DecrementType >::my_count, tbb::flow::interface11::graph_node::my_graph, tbb::flow::interface11::limiter_node< T, DecrementType >::my_mutex, tbb::flow::interface11::limiter_node< T, DecrementType >::my_predecessors, tbb::flow::interface11::limiter_node< T, DecrementType >::my_successors, tbb::flow::interface11::limiter_node< T, DecrementType >::my_threshold, tbb::flow::interface11::limiter_node< T, DecrementType >::my_tries, tbb::flow::interface10::graph::root_task(), and tbb::flow::interface11::internal::spawn_in_graph_arena().

Here is the call graph for this function:

## register_successor()

template<typename T , typename DecrementType = continue_msg>

bool tbb::flow::interface11::limiter_node< T, DecrementType >::register_successor | ( | successor_type & | r | ) |

inline virtual

Replace the current successor with this new successor.

Implements tbb::flow::interface11::internal::untyped_sender.

Definition at line 3146 of file flow_graph.h.

{
spin_mutex::scoped_lock lock(my_mutex);
bool was_empty = my_successors.empty();
my_successors.register_successor(r);
//spawn a forward task if this is the only successor
if ( was_empty && !my_predecessors.empty() && my_count + my_tries < my_threshold ) {
if ( internal::is_graph_active(this->my_graph) ) {
task* task = new ( task::allocate_additional_child_of( *(this->my_graph.root_task()) ) )
internal::forward_task_bypass < limiter_node<T, DecrementType> >( *this );
internal::spawn_in_graph_arena(graph_reference(), *task);
}
}
return true;
}

References tbb::flow::interface11::limiter_node< T, DecrementType >::graph_reference(), tbb::flow::interface11::internal::is_graph_active(), lock, tbb::flow::interface11::limiter_node< T, DecrementType >::my_count, tbb::flow::interface11::graph_node::my_graph, tbb::flow::interface11::limiter_node< T, DecrementType >::my_mutex, tbb::flow::interface11::limiter_node< T, DecrementType >::my_predecessors, tbb::flow::interface11::limiter_node< T, DecrementType >::my_successors, tbb::flow::interface11::limiter_node< T, DecrementType >::my_threshold, tbb::flow::interface11::limiter_node< T, DecrementType >::my_tries, tbb::flow::interface10::graph::root_task(), and tbb::flow::interface11::internal::spawn_in_graph_arena().

Here is the call graph for this function:

## remove_predecessor()

template<typename T , typename DecrementType = continue_msg>

bool tbb::flow::interface11::limiter_node< T, DecrementType >::remove_predecessor | ( | predecessor_type & | src | ) |

inline virtual

Removes src from the list of cached predecessors.

Reimplemented from tbb::flow::interface11::internal::untyped_receiver.

Definition at line 3222 of file flow_graph.h.

{
my_predecessors.remove( src );
return true;
}

References tbb::flow::interface11::limiter_node< T, DecrementType >::my_predecessors.

## remove_successor()

template<typename T , typename DecrementType = continue_msg>

bool tbb::flow::interface11::limiter_node< T, DecrementType >::remove_successor | ( | successor_type & | r | ) |

inline virtual

Removes a successor from this node.

r.remove_predecessor(*this) is also called.

Implements tbb::flow::interface11::internal::untyped_sender.

Definition at line 3163 of file flow_graph.h.

{
r.remove_predecessor(*this);
my_successors.remove_successor(r);
return true;
}

References tbb::flow::interface11::limiter_node< T, DecrementType >::my_successors.

## reset_node()

template<typename T , typename DecrementType = continue_msg>

void tbb::flow::interface11::limiter_node< T, DecrementType >::reset_node | ( | reset_flags | f | ) |

inline protected virtual

Implements tbb::flow::interface11::graph_node.

Definition at line 3266 of file flow_graph.h.

{
my_count = 0;
if(f & rf_clear_edges) {
my_predecessors.clear();
my_successors.clear();
}
else
{
my_predecessors.reset( );
}
decrement.reset_receiver(f);
}
tbb::flow::interface11::rf_clear_edges
@ rf_clear_edges
Definition: _flow_graph_impl.h:161

References tbb::flow::interface11::limiter_node< T, DecrementType >::decrement, tbb::flow::interface11::limiter_node< T, DecrementType >::my_count, tbb::flow::interface11::limiter_node< T, DecrementType >::my_predecessors, tbb::flow::interface11::limiter_node< T, DecrementType >::my_successors, and tbb::flow::interface11::rf_clear_edges.

## reset_receiver()

template<typename T , typename DecrementType = continue_msg>

void tbb::flow::interface11::limiter_node< T, DecrementType >::reset_receiver | ( | reset_flags | f | ) |

inline protected virtual

put receiver back in initial state

Implements tbb::flow::interface11::internal::untyped_receiver.

Definition at line 3262 of file flow_graph.h.

{
__TBB_ASSERT(false,NULL); // should never be called
}

References __TBB_ASSERT.

## try_put_task()

template<typename T , typename DecrementType = continue_msg>

task* tbb::flow::interface11::limiter_node< T, DecrementType >::try_put_task | ( | const T & | t | ) |

inline protected virtual

Puts an item to this receiver.

Implements tbb::flow::interface11::receiver< T >.

Definition at line 3233 of file flow_graph.h.

{
{
spin_mutex::scoped_lock lock(my_mutex);
if ( my_count + my_tries >= my_threshold )
return NULL;
else
++my_tries;
}
task * rtask = my_successors.try_put_task(t);
if ( !rtask ) { // try_put_task failed.
spin_mutex::scoped_lock lock(my_mutex);
--my_tries;
if (check_conditions() && internal::is_graph_active(this->my_graph)) {
rtask = new ( task::allocate_additional_child_of( *(this->my_graph.root_task()) ) )
internal::forward_task_bypass< limiter_node<T, DecrementType> >( *this );
}
}
else {
spin_mutex::scoped_lock lock(my_mutex);
++my_count;
--my_tries;
}
return rtask;
}

References tbb::flow::interface11::limiter_node< T, DecrementType >::check_conditions(), tbb::flow::interface11::internal::is_graph_active(), lock, tbb::flow::interface11::limiter_node< T, DecrementType >::my_count, tbb::flow::interface11::graph_node::my_graph, tbb::flow::interface11::limiter_node< T, DecrementType >::my_mutex, tbb::flow::interface11::limiter_node< T, DecrementType >::my_successors, tbb::flow::interface11::limiter_node< T, DecrementType >::my_threshold, tbb::flow::interface11::limiter_node< T, DecrementType >::my_tries, and tbb::flow::interface10::graph::root_task().

Here is the call graph for this function:

## Friends And Related Function Documentation

## internal::broadcast_cache

template<typename T , typename DecrementType = continue_msg>
template<typename X , typename Y >

friend class internal::broadcast_cache

friend

Definition at line 3230 of file flow_graph.h.

## internal::decrementer< limiter_node< T, DecrementType >, DecrementType >

template<typename T , typename DecrementType = continue_msg>

friend class internal::decrementer< limiter_node< T, DecrementType >, DecrementType >

friend

Definition at line 3005 of file flow_graph.h.

## internal::forward_task_bypass< limiter_node< T, DecrementType > >

template<typename T , typename DecrementType = continue_msg>

friend class internal::forward_task_bypass< limiter_node< T, DecrementType > >

friend

Definition at line 3005 of file flow_graph.h.

## internal::round_robin_cache

template<typename T , typename DecrementType = continue_msg>
template<typename X , typename Y >

friend class internal::round_robin_cache

friend

Definition at line 3231 of file flow_graph.h.

## run_and_put_task

template<typename T , typename DecrementType = continue_msg>
template<typename R , typename B >

friend class run_and_put_task

friend

Definition at line 3229 of file flow_graph.h.

## Member Data Documentation

## decrement

template<typename T , typename DecrementType = continue_msg>

internal::decrementer< limiter_node<T, DecrementType>, DecrementType > tbb::flow::interface11::limiter_node< T, DecrementType >::decrement

The internal receiver< DecrementType > that decrements the count.

Definition at line 3101 of file flow_graph.h.

Referenced by tbb::flow::interface11::limiter_node< T, DecrementType >::initialize(), and tbb::flow::interface11::limiter_node< T, DecrementType >::reset_node().

## my_count

template<typename T , typename DecrementType = continue_msg>

size_t tbb::flow::interface11::limiter_node< T, DecrementType >::my_count

private

Definition at line 3001 of file flow_graph.h.

Referenced by tbb::flow::interface11::limiter_node< T, DecrementType >::check_conditions(), tbb::flow::interface11::limiter_node< T, DecrementType >::decrement_counter(), tbb::flow::interface11::limiter_node< T, DecrementType >::forward_task(), tbb::flow::interface11::limiter_node< T, DecrementType >::register_predecessor(), tbb::flow::interface11::limiter_node< T, DecrementType >::register_successor(), tbb::flow::interface11::limiter_node< T, DecrementType >::reset_node(), and tbb::flow::interface11::limiter_node< T, DecrementType >::try_put_task().

## my_mutex

template<typename T , typename DecrementType = continue_msg>

spin_mutex tbb::flow::interface11::limiter_node< T, DecrementType >::my_mutex

private

Definition at line 3004 of file flow_graph.h.

Referenced by tbb::flow::interface11::limiter_node< T, DecrementType >::decrement_counter(), tbb::flow::interface11::limiter_node< T, DecrementType >::forward_task(), tbb::flow::interface11::limiter_node< T, DecrementType >::register_predecessor(), tbb::flow::interface11::limiter_node< T, DecrementType >::register_successor(), and tbb::flow::interface11::limiter_node< T, DecrementType >::try_put_task().

## my_predecessors

template<typename T , typename DecrementType = continue_msg>

internal::reservable_predecessor_cache< T, spin_mutex > tbb::flow::interface11::limiter_node< T, DecrementType >::my_predecessors

private

Definition at line 3003 of file flow_graph.h.

Referenced by tbb::flow::interface11::limiter_node< T, DecrementType >::check_conditions(), tbb::flow::interface11::limiter_node< T, DecrementType >::forward_task(), tbb::flow::interface11::limiter_node< T, DecrementType >::initialize(), tbb::flow::interface11::limiter_node< T, DecrementType >::register_predecessor(), tbb::flow::interface11::limiter_node< T, DecrementType >::register_successor(), tbb::flow::interface11::limiter_node< T, DecrementType >::remove_predecessor(), and tbb::flow::interface11::limiter_node< T, DecrementType >::reset_node().

## my_successors

template<typename T , typename DecrementType = continue_msg>

internal::broadcast_cache< T > tbb::flow::interface11::limiter_node< T, DecrementType >::my_successors

private

Definition at line 3005 of file flow_graph.h.

Referenced by tbb::flow::interface11::limiter_node< T, DecrementType >::check_conditions(), tbb::flow::interface11::limiter_node< T, DecrementType >::forward_task(), tbb::flow::interface11::limiter_node< T, DecrementType >::initialize(), tbb::flow::interface11::limiter_node< T, DecrementType >::register_predecessor(), tbb::flow::interface11::limiter_node< T, DecrementType >::register_successor(), tbb::flow::interface11::limiter_node< T, DecrementType >::remove_successor(), tbb::flow::interface11::limiter_node< T, DecrementType >::reset_node(), and tbb::flow::interface11::limiter_node< T, DecrementType >::try_put_task().

## my_threshold

template<typename T , typename DecrementType = continue_msg>

size_t tbb::flow::interface11::limiter_node< T, DecrementType >::my_threshold

private

Definition at line 3000 of file flow_graph.h.

Referenced by tbb::flow::interface11::limiter_node< T, DecrementType >::check_conditions(), tbb::flow::interface11::limiter_node< T, DecrementType >::decrement_counter(), tbb::flow::interface11::limiter_node< T, DecrementType >::register_predecessor(), tbb::flow::interface11::limiter_node< T, DecrementType >::register_successor(), and tbb::flow::interface11::limiter_node< T, DecrementType >::try_put_task().

## my_tries

template<typename T , typename DecrementType = continue_msg>

size_t tbb::flow::interface11::limiter_node< T, DecrementType >::my_tries

private

Definition at line 3002 of file flow_graph.h.

Referenced by tbb::flow::interface11::limiter_node< T, DecrementType >::check_conditions(), tbb::flow::interface11::limiter_node< T, DecrementType >::forward_task(), tbb::flow::interface11::limiter_node< T, DecrementType >::register_predecessor(), tbb::flow::interface11::limiter_node< T, DecrementType >::register_successor(), and tbb::flow::interface11::limiter_node< T, DecrementType >::try_put_task().

The documentation for this class was generated from the following file:

- flow_graph.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.